//--------------------------------------------------
//
// SUMO ROBOT 
//
//


#include <AFMotor.h>
#include <SoftwareSerial.h>


SoftwareSerial mySerial(9, 10); // RX, TX


AF_DCMotor motor_bal(4);
AF_DCMotor motor_jobb(3);



//---------------------------------------
// bluetooth parancsok puffere

char c; 
char cmd[100];
int cmdIndex;


//---------------------------------
// érintőképernyő x, y korrdinátái
int px;
int py;


int bal_seb = 255;
int jobb_seb = 255;





void setup() {
  Serial.begin(9600);           // set up Serial library at 9600 bps
  Serial.println("Motor test!");

  mySerial.begin(9600);


  cmdIndex = 0;  

  // turn on motor
  motor_bal.setSpeed(200);
 
  motor_bal.run(RELEASE);
  motor_jobb.run(RELEASE);
}

void loop() {
  
  
  
  
  if(mySerial.available()) {
    
    char c = (char)mySerial.read();
    Serial.print(c);
    
    if(c=='\n') {
      cmd[cmdIndex] = 0;
      exeCmd();  // execute the command
      cmdIndex = 0; // reset the cmdIndex
    } else {      
      cmd[cmdIndex] = c;
      if(cmdIndex<99) cmdIndex++;
    }
    
  }  
  
  
  
//   motor_bal.run(FORWARD);
//   motor_bal.setSpeed(i);  
//   motor_bal.run(BACKWARD);

 

}










//---------------------------------------
// bluetooth parancsok feldolgozása

void exeCmd() {

  // -------------------------------------
  // touchpad xy A B
    
  if(cmd[0]=='x' &&
     cmd[1]=='y' &&
     cmd[2]==' ') {
       
         px = cmd[3]-'0';     
         py = cmd[5]-'0';

       
       

       

     //----------------------------------
     // FELSŐ SÁV

     if (py<4) {

        //----------------------
        // BAL OLDAL
         if (px<3)                   {   }
         if ((px>=3) && (px<=6))     {    }       
         if (px>6)                   {    }           
      }

     //----------------------------------
     // ALSÓ SÁV

     if (py>4) {

        //----------------------
        // BAL OLDAL
         if (px<3)                   {   }
         if ((px>=3) && (px<=6))     {   }       
         if (px>6)                   {  }           
      }

       
      
     }


  
  // -------------------------------------
  // sebesség állítása
    
  if(cmd[0]=='b' &&
     cmd[1]=='s' &&
     cmd[2]=='e' &&
     cmd[3]=='b' &&
     cmd[4]==' ') {
       
       int val = 0;
       for(int i=5; cmd[i]!=0; i++) {
         val = val*10 + (cmd[i]-'0');
       }
       
       bal_seb=val;      
    
     }   


  if(cmd[0]=='j' &&
     cmd[1]=='s' &&
     cmd[2]=='e' &&
     cmd[3]=='b' &&
     cmd[4]==' ') {
       
       int val = 0;
       for(int i=5; cmd[i]!=0; i++) {
         val = val*10 + (cmd[i]-'0');
       }
       
       jobb_seb=val;      
    
     }   




//------------------------
// előre bal

  if(cmd[0]=='b' &&
     cmd[1]=='e' ) {
      
      motor_bal.run(FORWARD);
      motor_bal.setSpeed(bal_seb);  
   
   }


//------------------------
// előre jobb

  if(cmd[0]=='j' &&
     cmd[1]=='e' ) {
      
      motor_jobb.run(FORWARD);
      motor_jobb.setSpeed(jobb_seb);  
   
   }




//------------------------
// hátra bal

  if(cmd[0]=='b' &&
     cmd[1]=='h' ) {
      
      motor_bal.run(BACKWARD);
      motor_bal.setSpeed(bal_seb);  
   
   }


//------------------------
// hátra jobb

  if(cmd[0]=='j' &&
     cmd[1]=='h' ) {
      
      motor_jobb.run(BACKWARD);
      motor_jobb.setSpeed(jobb_seb);  
   
   }




//------------------------
// fordul balra

  if(cmd[0]=='f' &&
     cmd[1]=='b' ) {
      
      motor_bal.run(BACKWARD);
      motor_bal.setSpeed(bal_seb);  

      motor_jobb.run(FORWARD);
      motor_jobb.setSpeed(jobb_seb);  

   
   }


//------------------------
// fordul jobbra

  if(cmd[0]=='f' &&
     cmd[1]=='j' ) {
      
      motor_bal.run(FORWARD);
      motor_bal.setSpeed(bal_seb);  

      motor_jobb.run(BACKWARD);
      motor_jobb.setSpeed(jobb_seb);  

   
   }



//------------------------
// ELŐRE

  if(cmd[0]=='e' &&
     cmd[1]=='e' ) {
      
      motor_bal.run(FORWARD);
      motor_bal.setSpeed(bal_seb);  

      motor_jobb.run(FORWARD);
      motor_jobb.setSpeed(jobb_seb);  

   
   }


//------------------------
// HÁTRA

  if(cmd[0]=='h' &&
     cmd[1]=='h' ) {
      
      motor_bal.run(BACKWARD);
      motor_bal.setSpeed(bal_seb);  

      motor_jobb.run(BACKWARD);
      motor_jobb.setSpeed(jobb_seb);  

   
   }





//------------------------
// stop
       
  if(cmd[0]=='s' &&
     cmd[1]=='t')  {


   motor_bal.setSpeed(0);  
   motor_jobb.setSpeed(0);  



   }
 




     
}
